{"changed":true,"filter":false,"title":"index-test.js","tooltip":"/test/index-test.js","value":"const ultimateChai = require('../');\nconst expect = ultimateChai.expect;\nconst sinon = require('sinon');\n\n\ndescribe('index.js', () => {\n  context('when ultimateChai is used', () => {\n    it('should have ok method from dirty-chai', (done) => {\n      expect('ok').to.be.ok();\n      done();\n    });\n    it('should have false method from dirty-chai', (done) => {\n      expect(true).to.be.true.and.not.false();\n      done();\n    });\n    it('should have true method from dirty-chai', (done) => {\n      expect(true).to.be.true();\n      done();\n    });\n    it('should have null method from dirty-chai', (done) => {\n      expect(null).to.be.null();\n      done();\n    });\n    it('should have exist method from dirty-chai', (done) => {\n      expect(undefined).to.be.undefined();\n      done();\n    });\n    it('should have exist method from dirty-chai', (done) => {\n      expect('test').to.exist();\n      done();\n    });\n    it('should have empty method from dirty-chai', (done) => {\n      expect('').to.be.empty();\n      done();\n    });\n    it('should have empty method from dirty-chai', (done) => {\n      expect('').to.be.empty();\n      done();\n    });\n  });\n  \n  context('when ultimateChai is used', () => {\n    const testspy = sinon.spy();\n    \n    it('should have called method from sinon-chai', () => {\n      testspy(\"foo\");    \n      expect(testspy).to.have.been.called();\n    });\n        \n    it('should have calledWith method from sinon-chai', () => {\n      testspy(\"foo\");    \n      expect(testspy).to.have.been.calledWith(\"foo\");\n    });\n    \n    it('should have calledWith method from sinon-chai', () => {\n      const callCountSpy = sinon.spy();\n      callCountSpy();\n      callCountSpy('foo');\n      callCountSpy('wow');\n      expect(callCountSpy).to.have.callCount(3);\n    });\n    \n    it('should have calledOnce method from sinon-chai', () => {\n      const callCountSpy = sinon.spy();\n      callCountSpy();\n      expect(callCountSpy).to.have.been.calledOnce();\n    });\n    \n    it('should have calledTwice method from sinon-chai', () => {\n      const callCountSpy = sinon.spy();\n      callCountSpy();\n      callCountSpy('foo');\n      expect(callCountSpy).to.have.been.calledTwice();\n    });\n    \n    it('should have calledThrice method from sinon-chai', () => {\n      const callCountSpy = sinon.spy();\n      callCountSpy();\n      callCountSpy('foo');\n      callCountSpy('bar');\n      expect(callCountSpy).to.have.been.calledThrice();\n    });\n    \n    it('should have calledBefore method from sinon-chai', () => {\n      const spy1 = sinon.spy();\n      const spy2 = sinon.spy();\n      spy1();\n      spy2();\n      expect(spy1).to.have.been.calledBefore(spy2);\n    });\n    \n    it('should have calledBefore method from sinon-chai', () => {\n      const spy1 = sinon.spy();\n      const spy2 = sinon.spy();\n      spy1();\n      spy2();\n      expect(spy1).to.have.been.calledBefore(spy2);\n    });\n    \n    it('should have calledAfter method from sinon-chai', () => {\n      const spy1 = sinon.spy();\n      const spy2 = sinon.spy();\n      spy1();\n      spy2();\n      expect(spy2).to.have.been.calledAfter(spy1);\n    });\n    \n    it('should have calledAfter method from sinon-chai', () => {\n      const spy = sinon.spy();\n      new spy();\n      expect(spy).to.have.been.calledWithNew();\n    });\n    \n    it('should have alwaysCalledWithNew method from sinon-chai', () => {\n      const spy = sinon.spy();\n      new spy();\n      new spy();\n      expect(spy).to.always.have.been.calledWithNew();\n    });\n    \n  });\n  \n  context('when ultimateChai is used', () => {\n    const sampleSuccess = () => new Promise((resolve, reject) => {\n     setTimeout(function(){\n       resolve({foo: \"bar\"});\n     },100); \n    });\n    \n    const sampleReject = () => new Promise((resolve, reject) => {\n     setTimeout(function(){\n       reject(new Error('error'));\n     },100); \n    });\n        \n    it('should have eventually method from chai-as-promised', () => {\n      return expect(sampleSuccess()).to.eventually.have.property(\"foo\");\n    });\n    \n    it('should have fulfilled method from chai-as-promised', () => {\n      return expect(sampleSuccess()).to.be.fulfilled();\n    });\n    \n    it('should have become method from chai-as-promised', () => {\n      return expect(sampleSuccess()).to.become({foo: \"bar\"});\n    });\n    \n    it('should have rejected method from chai-as-promised', () => {\n      return expect(sampleReject()).to.be.rejected();\n    });\n    \n    it('should have rejected method from chai-as-promised', () => {\n      return expect(sampleReject()).to.be.rejectedWith(Error);\n    });\n    \n  });\n\n});","undoManager":{"mark":100,"position":100,"stack":[[{"start":{"row":99,"column":23},"end":{"row":99,"column":24},"action":"insert","lines":["l"],"id":1300}],[{"start":{"row":99,"column":24},"end":{"row":99,"column":25},"action":"insert","lines":["e"],"id":1301}],[{"start":{"row":99,"column":25},"end":{"row":99,"column":26},"action":"insert","lines":["d"],"id":1302}],[{"start":{"row":99,"column":26},"end":{"row":99,"column":27},"action":"insert","lines":["A"],"id":1303}],[{"start":{"row":99,"column":27},"end":{"row":99,"column":28},"action":"insert","lines":["f"],"id":1304}],[{"start":{"row":99,"column":28},"end":{"row":99,"column":29},"action":"insert","lines":["t"],"id":1305}],[{"start":{"row":99,"column":29},"end":{"row":99,"column":30},"action":"insert","lines":["e"],"id":1306}],[{"start":{"row":99,"column":30},"end":{"row":99,"column":31},"action":"insert","lines":["r"],"id":1307}],[{"start":{"row":104,"column":32},"end":{"row":104,"column":44},"action":"remove","lines":["calledBefore"],"id":1308},{"start":{"row":104,"column":32},"end":{"row":104,"column":43},"action":"insert","lines":["calledAfter"]}],[{"start":{"row":104,"column":16},"end":{"row":104,"column":17},"action":"remove","lines":["1"],"id":1309}],[{"start":{"row":104,"column":16},"end":{"row":104,"column":17},"action":"insert","lines":["2"],"id":1310}],[{"start":{"row":104,"column":47},"end":{"row":104,"column":48},"action":"remove","lines":["2"],"id":1311}],[{"start":{"row":104,"column":47},"end":{"row":104,"column":48},"action":"insert","lines":["1"],"id":1312}],[{"start":{"row":104,"column":16},"end":{"row":104,"column":17},"action":"remove","lines":["2"],"id":1313}],[{"start":{"row":104,"column":16},"end":{"row":104,"column":17},"action":"insert","lines":["1"],"id":1314}],[{"start":{"row":104,"column":47},"end":{"row":104,"column":48},"action":"remove","lines":["1"],"id":1315}],[{"start":{"row":104,"column":47},"end":{"row":104,"column":48},"action":"insert","lines":["2"],"id":1316}],[{"start":{"row":104,"column":16},"end":{"row":104,"column":17},"action":"remove","lines":["1"],"id":1317}],[{"start":{"row":104,"column":16},"end":{"row":104,"column":17},"action":"insert","lines":["2"],"id":1318}],[{"start":{"row":104,"column":47},"end":{"row":104,"column":48},"action":"remove","lines":["2"],"id":1319}],[{"start":{"row":104,"column":47},"end":{"row":104,"column":48},"action":"insert","lines":["1"],"id":1320}],[{"start":{"row":105,"column":7},"end":{"row":106,"column":0},"action":"insert","lines":["",""],"id":1321},{"start":{"row":106,"column":0},"end":{"row":106,"column":4},"action":"insert","lines":["    "]}],[{"start":{"row":106,"column":4},"end":{"row":107,"column":0},"action":"insert","lines":["",""],"id":1322},{"start":{"row":107,"column":0},"end":{"row":107,"column":4},"action":"insert","lines":["    "]}],[{"start":{"row":107,"column":4},"end":{"row":113,"column":7},"action":"insert","lines":["it('should have calledAfter method from sinon-chai', () => {","      const spy1 = sinon.spy();","      const spy2 = sinon.spy();","      spy1();","      spy2();","      expect(spy2).to.have.been.calledAfter(spy1);","    });"],"id":1323}],[{"start":{"row":108,"column":31},"end":{"row":109,"column":31},"action":"remove","lines":["","      const spy2 = sinon.spy();"],"id":1324}],[{"start":{"row":109,"column":6},"end":{"row":109,"column":7},"action":"insert","lines":["c"],"id":1325}],[{"start":{"row":109,"column":7},"end":{"row":109,"column":8},"action":"insert","lines":["o"],"id":1326}],[{"start":{"row":109,"column":8},"end":{"row":109,"column":9},"action":"insert","lines":["n"],"id":1327}],[{"start":{"row":109,"column":9},"end":{"row":109,"column":10},"action":"insert","lines":["s"],"id":1328}],[{"start":{"row":109,"column":10},"end":{"row":109,"column":11},"action":"insert","lines":["t"],"id":1329}],[{"start":{"row":109,"column":11},"end":{"row":109,"column":12},"action":"insert","lines":[" "],"id":1330}],[{"start":{"row":109,"column":12},"end":{"row":109,"column":13},"action":"insert","lines":["t"],"id":1331}],[{"start":{"row":109,"column":13},"end":{"row":109,"column":14},"action":"insert","lines":["e"],"id":1332}],[{"start":{"row":109,"column":14},"end":{"row":109,"column":15},"action":"insert","lines":["s"],"id":1333}],[{"start":{"row":109,"column":15},"end":{"row":109,"column":16},"action":"insert","lines":["t"],"id":1334}],[{"start":{"row":109,"column":16},"end":{"row":109,"column":17},"action":"insert","lines":[" "],"id":1335}],[{"start":{"row":109,"column":16},"end":{"row":109,"column":17},"action":"remove","lines":[" "],"id":1336}],[{"start":{"row":109,"column":15},"end":{"row":109,"column":16},"action":"remove","lines":["t"],"id":1337}],[{"start":{"row":109,"column":14},"end":{"row":109,"column":15},"action":"remove","lines":["s"],"id":1338}],[{"start":{"row":109,"column":13},"end":{"row":109,"column":14},"action":"remove","lines":["e"],"id":1339}],[{"start":{"row":109,"column":12},"end":{"row":109,"column":13},"action":"remove","lines":["t"],"id":1340}],[{"start":{"row":109,"column":11},"end":{"row":109,"column":12},"action":"remove","lines":[" "],"id":1341}],[{"start":{"row":109,"column":10},"end":{"row":109,"column":11},"action":"remove","lines":["t"],"id":1342}],[{"start":{"row":109,"column":9},"end":{"row":109,"column":10},"action":"remove","lines":["s"],"id":1343}],[{"start":{"row":109,"column":8},"end":{"row":109,"column":9},"action":"remove","lines":["n"],"id":1344}],[{"start":{"row":109,"column":7},"end":{"row":109,"column":8},"action":"remove","lines":["o"],"id":1345}],[{"start":{"row":109,"column":6},"end":{"row":109,"column":7},"action":"remove","lines":["c"],"id":1346}],[{"start":{"row":109,"column":6},"end":{"row":109,"column":7},"action":"insert","lines":["n"],"id":1347}],[{"start":{"row":109,"column":7},"end":{"row":109,"column":8},"action":"insert","lines":["e"],"id":1348}],[{"start":{"row":109,"column":8},"end":{"row":109,"column":9},"action":"insert","lines":["w"],"id":1349}],[{"start":{"row":109,"column":9},"end":{"row":109,"column":10},"action":"insert","lines":[" "],"id":1350}],[{"start":{"row":109,"column":17},"end":{"row":110,"column":13},"action":"remove","lines":["","      spy2();"],"id":1351}],[{"start":{"row":108,"column":15},"end":{"row":108,"column":16},"action":"remove","lines":["1"],"id":1352}],[{"start":{"row":109,"column":13},"end":{"row":109,"column":14},"action":"remove","lines":["1"],"id":1353}],[{"start":{"row":110,"column":13},"end":{"row":110,"column":17},"action":"remove","lines":["spy2"],"id":1354},{"start":{"row":110,"column":13},"end":{"row":110,"column":16},"action":"insert","lines":["spy"]}],[{"start":{"row":110,"column":31},"end":{"row":110,"column":42},"action":"remove","lines":["calledAfter"],"id":1355},{"start":{"row":110,"column":31},"end":{"row":110,"column":65},"action":"insert","lines":["spy.should.have.been.calledWithNew"]}],[{"start":{"row":110,"column":31},"end":{"row":110,"column":51},"action":"remove","lines":["spy.should.have.been"],"id":1356}],[{"start":{"row":110,"column":30},"end":{"row":110,"column":31},"action":"remove","lines":["."],"id":1357}],[{"start":{"row":110,"column":45},"end":{"row":110,"column":49},"action":"remove","lines":["spy1"],"id":1358}],[{"start":{"row":109,"column":9},"end":{"row":109,"column":10},"action":"remove","lines":[" "],"id":1359}],[{"start":{"row":109,"column":8},"end":{"row":109,"column":9},"action":"remove","lines":["w"],"id":1360}],[{"start":{"row":109,"column":7},"end":{"row":109,"column":8},"action":"remove","lines":["e"],"id":1361}],[{"start":{"row":109,"column":6},"end":{"row":109,"column":7},"action":"remove","lines":["n"],"id":1362}],[{"start":{"row":109,"column":6},"end":{"row":109,"column":7},"action":"insert","lines":["n"],"id":1363}],[{"start":{"row":109,"column":7},"end":{"row":109,"column":8},"action":"insert","lines":["e"],"id":1364}],[{"start":{"row":109,"column":8},"end":{"row":109,"column":9},"action":"insert","lines":["w"],"id":1365}],[{"start":{"row":109,"column":9},"end":{"row":109,"column":10},"action":"insert","lines":[" "],"id":1366}],[{"start":{"row":111,"column":7},"end":{"row":112,"column":0},"action":"insert","lines":["",""],"id":1367},{"start":{"row":112,"column":0},"end":{"row":112,"column":4},"action":"insert","lines":["    "]}],[{"start":{"row":112,"column":4},"end":{"row":113,"column":0},"action":"insert","lines":["",""],"id":1368},{"start":{"row":113,"column":0},"end":{"row":113,"column":4},"action":"insert","lines":["    "]}],[{"start":{"row":113,"column":4},"end":{"row":117,"column":7},"action":"insert","lines":["it('should have calledAfter method from sinon-chai', () => {","      const spy = sinon.spy();","      new spy();","      expect(spy).to.have.been.calledWithNew();","    });"],"id":1369}],[{"start":{"row":115,"column":16},"end":{"row":116,"column":0},"action":"insert","lines":["",""],"id":1370},{"start":{"row":116,"column":0},"end":{"row":116,"column":6},"action":"insert","lines":["      "]}],[{"start":{"row":116,"column":6},"end":{"row":116,"column":7},"action":"insert","lines":["s"],"id":1371}],[{"start":{"row":116,"column":7},"end":{"row":116,"column":8},"action":"insert","lines":["p"],"id":1372}],[{"start":{"row":116,"column":8},"end":{"row":116,"column":9},"action":"insert","lines":["y"],"id":1373}],[{"start":{"row":116,"column":9},"end":{"row":116,"column":11},"action":"insert","lines":["()"],"id":1374}],[{"start":{"row":116,"column":11},"end":{"row":116,"column":12},"action":"insert","lines":[";"],"id":1375}],[{"start":{"row":113,"column":20},"end":{"row":113,"column":31},"action":"remove","lines":["calledAfter"],"id":1376},{"start":{"row":113,"column":20},"end":{"row":113,"column":39},"action":"insert","lines":["alwaysCalledWithNew"]}],[{"start":{"row":117,"column":31},"end":{"row":117,"column":44},"action":"remove","lines":["calledWithNew"],"id":1377},{"start":{"row":117,"column":31},"end":{"row":117,"column":50},"action":"insert","lines":["alwaysCalledWithNew"]}],[{"start":{"row":116,"column":6},"end":{"row":116,"column":7},"action":"insert","lines":["n"],"id":1378}],[{"start":{"row":116,"column":7},"end":{"row":116,"column":8},"action":"insert","lines":["e"],"id":1379}],[{"start":{"row":116,"column":8},"end":{"row":116,"column":9},"action":"insert","lines":["w"],"id":1380}],[{"start":{"row":116,"column":9},"end":{"row":116,"column":10},"action":"insert","lines":[" "],"id":1381}],[{"start":{"row":117,"column":31},"end":{"row":117,"column":50},"action":"remove","lines":["alwaysCalledWithNew"],"id":1382},{"start":{"row":117,"column":31},"end":{"row":117,"column":44},"action":"insert","lines":["calledWithNew"]}],[{"start":{"row":116,"column":9},"end":{"row":116,"column":10},"action":"remove","lines":[" "],"id":1383}],[{"start":{"row":116,"column":8},"end":{"row":116,"column":9},"action":"remove","lines":["w"],"id":1384}],[{"start":{"row":116,"column":7},"end":{"row":116,"column":8},"action":"remove","lines":["e"],"id":1385}],[{"start":{"row":116,"column":6},"end":{"row":116,"column":7},"action":"remove","lines":["n"],"id":1386}],[{"start":{"row":114,"column":30},"end":{"row":115,"column":0},"action":"insert","lines":["",""],"id":1387},{"start":{"row":115,"column":0},"end":{"row":115,"column":6},"action":"insert","lines":["      "]}],[{"start":{"row":115,"column":6},"end":{"row":115,"column":7},"action":"insert","lines":["s"],"id":1388}],[{"start":{"row":115,"column":7},"end":{"row":115,"column":8},"action":"insert","lines":["p"],"id":1389}],[{"start":{"row":115,"column":8},"end":{"row":115,"column":9},"action":"insert","lines":["y"],"id":1390}],[{"start":{"row":115,"column":9},"end":{"row":115,"column":11},"action":"insert","lines":["()"],"id":1391}],[{"start":{"row":115,"column":11},"end":{"row":115,"column":12},"action":"insert","lines":[";"],"id":1392}],[{"start":{"row":118,"column":21},"end":{"row":118,"column":27},"action":"insert","lines":["always"],"id":1393}],[{"start":{"row":118,"column":27},"end":{"row":118,"column":28},"action":"insert","lines":["."],"id":1394}],[{"start":{"row":115,"column":0},"end":{"row":115,"column":12},"action":"remove","lines":["      spy();"],"id":1395}],[{"start":{"row":114,"column":30},"end":{"row":115,"column":0},"action":"remove","lines":["",""],"id":1396}],[{"start":{"row":116,"column":6},"end":{"row":116,"column":7},"action":"insert","lines":["n"],"id":1397}],[{"start":{"row":116,"column":7},"end":{"row":116,"column":8},"action":"insert","lines":["e"],"id":1398}],[{"start":{"row":116,"column":8},"end":{"row":116,"column":9},"action":"insert","lines":["w"],"id":1399}],[{"start":{"row":116,"column":9},"end":{"row":116,"column":10},"action":"insert","lines":[" "],"id":1400}],[{"start":{"row":6,"column":0},"end":{"row":7,"column":42},"action":"insert","lines":["const React =  require('react');","    const mount = require('enzyme').mount;"],"id":1484}],[{"start":{"row":5,"column":0},"end":{"row":6,"column":0},"action":"insert","lines":["",""],"id":1484}],[{"start":{"row":4,"column":31},"end":{"row":5,"column":0},"action":"insert","lines":["",""],"id":1485}],[{"start":{"row":159,"column":46},"end":{"row":160,"column":0},"action":"remove","lines":["",""],"id":1486}],[{"start":{"row":160,"column":0},"end":{"row":160,"column":4},"action":"remove","lines":["    "],"id":1487}],[{"start":{"row":160,"column":4},"end":{"row":161,"column":0},"action":"remove","lines":["",""],"id":1488}],[{"start":{"row":161,"column":0},"end":{"row":161,"column":4},"action":"remove","lines":["    "],"id":1489}],[{"start":{"row":160,"column":4},"end":{"row":161,"column":42},"action":"remove","lines":["const React =  require('react');","    const mount = require('enzyme').mount;"],"id":1490}],[{"start":{"row":0,"column":13},"end":{"row":1,"column":0},"action":"insert","lines":["",""],"id":1491}],[{"start":{"row":0,"column":12},"end":{"row":0,"column":13},"action":"insert","lines":[";"],"id":1492}],[{"start":{"row":0,"column":10},"end":{"row":0,"column":11},"action":"insert","lines":["t"],"id":1493}],[{"start":{"row":0,"column":9},"end":{"row":0,"column":10},"action":"insert","lines":["c"],"id":1494}],[{"start":{"row":0,"column":8},"end":{"row":0,"column":9},"action":"insert","lines":["i"],"id":1495}],[{"start":{"row":0,"column":7},"end":{"row":0,"column":8},"action":"insert","lines":["r"],"id":1496}],[{"start":{"row":0,"column":6},"end":{"row":0,"column":7},"action":"insert","lines":["t"],"id":1497}],[{"start":{"row":0,"column":5},"end":{"row":0,"column":6},"action":"insert","lines":["s"],"id":1498}],[{"start":{"row":0,"column":4},"end":{"row":0,"column":5},"action":"insert","lines":[" "],"id":1499}],[{"start":{"row":0,"column":3},"end":{"row":0,"column":4},"action":"insert","lines":["e"],"id":1500}],[{"start":{"row":0,"column":2},"end":{"row":0,"column":3},"action":"insert","lines":["s"],"id":1501}],[{"start":{"row":0,"column":1},"end":{"row":0,"column":2},"action":"insert","lines":["u"],"id":1502}],[{"start":{"row":0,"column":0},"end":{"row":0,"column":2},"action":"insert","lines":["''"],"id":1503}],[{"start":{"row":0,"column":0},"end":{"row":1,"column":0},"action":"insert","lines":["",""],"id":1504}],[{"start":{"row":159,"column":41},"end":{"row":159,"column":42},"action":"insert","lines":[";"],"id":1505}],[{"start":{"row":159,"column":40},"end":{"row":159,"column":41},"action":"insert","lines":["t"],"id":1506}],[{"start":{"row":159,"column":39},"end":{"row":159,"column":40},"action":"insert","lines":["n"],"id":1507}],[{"start":{"row":159,"column":38},"end":{"row":159,"column":39},"action":"insert","lines":["u"],"id":1508}],[{"start":{"row":159,"column":37},"end":{"row":159,"column":38},"action":"insert","lines":["o"],"id":1509}],[{"start":{"row":159,"column":36},"end":{"row":159,"column":37},"action":"insert","lines":["m"],"id":1510}],[{"start":{"row":159,"column":35},"end":{"row":159,"column":36},"action":"insert","lines":["."],"id":1511}],[{"start":{"row":159,"column":35},"end":{"row":159,"column":36},"action":"remove","lines":["/"],"id":1512}],[{"start":{"row":159,"column":35},"end":{"row":159,"column":36},"action":"insert","lines":["/"],"id":1513}],[{"start":{"row":159,"column":34},"end":{"row":159,"column":35},"action":"insert","lines":[")"],"id":1514}],[{"start":{"row":159,"column":25},"end":{"row":159,"column":26},"action":"insert","lines":["("],"id":1515}],[{"start":{"row":159,"column":24},"end":{"row":159,"column":25},"action":"insert","lines":["e"],"id":1516}],[{"start":{"row":159,"column":23},"end":{"row":159,"column":24},"action":"insert","lines":["r"],"id":1517}],[{"start":{"row":159,"column":22},"end":{"row":159,"column":23},"action":"insert","lines":["i"],"id":1518}],[{"start":{"row":159,"column":21},"end":{"row":159,"column":22},"action":"insert","lines":["u"],"id":1519}],[{"start":{"row":159,"column":20},"end":{"row":159,"column":21},"action":"insert","lines":["q"],"id":1520}],[{"start":{"row":159,"column":20},"end":{"row":159,"column":21},"action":"remove","lines":[" "],"id":1521}],[{"start":{"row":159,"column":19},"end":{"row":159,"column":20},"action":"insert","lines":["e"],"id":1522}],[{"start":{"row":159,"column":19},"end":{"row":159,"column":20},"action":"remove","lines":["q"],"id":1523}],[{"start":{"row":159,"column":19},"end":{"row":159,"column":20},"action":"insert","lines":["q"],"id":1524}],[{"start":{"row":159,"column":18},"end":{"row":159,"column":19},"action":"insert","lines":["r"],"id":1525}],[{"start":{"row":159,"column":17},"end":{"row":159,"column":18},"action":"insert","lines":[" "],"id":1526}],[{"start":{"row":159,"column":16},"end":{"row":159,"column":17},"action":"insert","lines":["="],"id":1527}],[{"start":{"row":159,"column":15},"end":{"row":159,"column":16},"action":"insert","lines":[" "],"id":1528}],[{"start":{"row":159,"column":15},"end":{"row":159,"column":38},"action":"remove","lines":[", render, shallow} from"],"id":1529}],[{"start":{"row":159,"column":10},"end":{"row":159,"column":11},"action":"remove","lines":["{"],"id":1530}],[{"start":{"row":159,"column":8},"end":{"row":159,"column":9},"action":"insert","lines":["t"],"id":1531}],[{"start":{"row":159,"column":7},"end":{"row":159,"column":8},"action":"insert","lines":["s"],"id":1532}],[{"start":{"row":159,"column":6},"end":{"row":159,"column":7},"action":"insert","lines":["n"],"id":1533}],[{"start":{"row":159,"column":5},"end":{"row":159,"column":6},"action":"insert","lines":["o"],"id":1534}],[{"start":{"row":159,"column":4},"end":{"row":159,"column":10},"action":"remove","lines":["import"],"id":1535},{"start":{"row":159,"column":4},"end":{"row":159,"column":5},"action":"insert","lines":["c"]}],[{"start":{"row":158,"column":35},"end":{"row":158,"column":36},"action":"insert","lines":[";"],"id":1536}],[{"start":{"row":158,"column":34},"end":{"row":158,"column":35},"action":"insert","lines":[")"],"id":1537}],[{"start":{"row":158,"column":26},"end":{"row":158,"column":27},"action":"insert","lines":["("],"id":1538}],[{"start":{"row":158,"column":25},"end":{"row":158,"column":26},"action":"insert","lines":["e"],"id":1539}],[{"start":{"row":158,"column":24},"end":{"row":158,"column":25},"action":"insert","lines":["r"],"id":1540}],[{"start":{"row":158,"column":23},"end":{"row":158,"column":24},"action":"insert","lines":["i"],"id":1541}],[{"start":{"row":158,"column":22},"end":{"row":158,"column":23},"action":"insert","lines":["u"],"id":1542}],[{"start":{"row":158,"column":21},"end":{"row":158,"column":22},"action":"insert","lines":["q"],"id":1543}],[{"start":{"row":158,"column":20},"end":{"row":158,"column":21},"action":"insert","lines":["e"],"id":1544}],[{"start":{"row":158,"column":19},"end":{"row":158,"column":20},"action":"insert","lines":["r"],"id":1545}],[{"start":{"row":158,"column":17},"end":{"row":158,"column":18},"action":"insert","lines":[" "],"id":1546}],[{"start":{"row":158,"column":16},"end":{"row":158,"column":17},"action":"insert","lines":["="],"id":1547}],[{"start":{"row":158,"column":16},"end":{"row":158,"column":17},"action":"remove","lines":["f"],"id":1548}],[{"start":{"row":158,"column":17},"end":{"row":158,"column":18},"action":"remove","lines":["r"],"id":1549}],[{"start":{"row":158,"column":18},"end":{"row":158,"column":19},"action":"remove","lines":["o"],"id":1550}],[{"start":{"row":158,"column":19},"end":{"row":158,"column":20},"action":"remove","lines":["m"],"id":1551}],[{"start":{"row":158,"column":8},"end":{"row":158,"column":9},"action":"insert","lines":["t"],"id":1552}],[{"start":{"row":158,"column":7},"end":{"row":158,"column":8},"action":"insert","lines":["s"],"id":1553}],[{"start":{"row":158,"column":6},"end":{"row":158,"column":7},"action":"insert","lines":["n"],"id":1554}],[{"start":{"row":158,"column":5},"end":{"row":158,"column":6},"action":"insert","lines":["o"],"id":1555}],[{"start":{"row":158,"column":4},"end":{"row":158,"column":10},"action":"remove","lines":["import"],"id":1556},{"start":{"row":158,"column":4},"end":{"row":158,"column":5},"action":"insert","lines":["c"]}],[{"start":{"row":159,"column":0},"end":{"row":159,"column":4},"action":"insert","lines":["    "],"id":1557},{"start":{"row":160,"column":0},"end":{"row":160,"column":4},"action":"insert","lines":["    "]},{"start":{"row":161,"column":0},"end":{"row":161,"column":4},"action":"insert","lines":["    "]},{"start":{"row":162,"column":0},"end":{"row":162,"column":4},"action":"insert","lines":["    "]},{"start":{"row":163,"column":0},"end":{"row":163,"column":4},"action":"insert","lines":["    "]},{"start":{"row":164,"column":0},"end":{"row":164,"column":4},"action":"insert","lines":["    "]},{"start":{"row":165,"column":0},"end":{"row":165,"column":4},"action":"insert","lines":["    "]},{"start":{"row":166,"column":0},"end":{"row":166,"column":4},"action":"insert","lines":["    "]},{"start":{"row":167,"column":0},"end":{"row":167,"column":4},"action":"insert","lines":["    "]},{"start":{"row":168,"column":0},"end":{"row":168,"column":4},"action":"insert","lines":["    "]},{"start":{"row":169,"column":0},"end":{"row":169,"column":4},"action":"insert","lines":["    "]},{"start":{"row":170,"column":0},"end":{"row":170,"column":4},"action":"insert","lines":["    "]},{"start":{"row":171,"column":0},"end":{"row":171,"column":4},"action":"insert","lines":["    "]},{"start":{"row":172,"column":0},"end":{"row":172,"column":4},"action":"insert","lines":["    "]},{"start":{"row":173,"column":0},"end":{"row":173,"column":4},"action":"insert","lines":["    "]},{"start":{"row":174,"column":0},"end":{"row":174,"column":4},"action":"insert","lines":["    "]},{"start":{"row":175,"column":0},"end":{"row":175,"column":4},"action":"insert","lines":["    "]},{"start":{"row":176,"column":0},"end":{"row":176,"column":4},"action":"insert","lines":["    "]},{"start":{"row":177,"column":0},"end":{"row":177,"column":4},"action":"insert","lines":["    "]},{"start":{"row":178,"column":0},"end":{"row":178,"column":4},"action":"insert","lines":["    "]},{"start":{"row":179,"column":0},"end":{"row":179,"column":4},"action":"insert","lines":["    "]},{"start":{"row":180,"column":0},"end":{"row":180,"column":4},"action":"insert","lines":["    "]},{"start":{"row":181,"column":0},"end":{"row":181,"column":4},"action":"insert","lines":["    "]},{"start":{"row":182,"column":0},"end":{"row":182,"column":4},"action":"insert","lines":["    "]},{"start":{"row":183,"column":0},"end":{"row":183,"column":4},"action":"insert","lines":["    "]},{"start":{"row":184,"column":0},"end":{"row":184,"column":4},"action":"insert","lines":["    "]}],[{"start":{"row":158,"column":4},"end":{"row":188,"column":7},"action":"remove","lines":["const sampleSuccess = () => new Promise((resolve, reject) => {","     setTimeout(function(){","       resolve({foo: \"bar\"});","     },100); ","    });","    ","    const sampleReject = () => new Promise((resolve, reject) => {","     setTimeout(function(){","       reject(new Error('error'));","     },100); ","    });","        ","    it('should have eventually method from chai-as-promised', () => {","      return expect(sampleSuccess()).to.eventually.have.property(\"foo\");","    });","    ","    it('should have fulfilled method from chai-as-promised', () => {","      return expect(sampleSuccess()).to.be.fulfilled();","    });","    ","    it('should have become method from chai-as-promised', () => {","      return expect(sampleSuccess()).to.become({foo: \"bar\"});","    });","    ","    it('should have rejected method from chai-as-promised', () => {","      return expect(sampleReject()).to.be.rejected();","    });","    ","    it('should have rejected method from chai-as-promised', () => {","      return expect(sampleReject()).to.be.rejectedWith(Error);","    });"],"id":1558},{"start":{"row":158,"column":4},"end":{"row":184,"column":49},"action":"insert","lines":["import React from 'react'","import {mount, render, shallow} from 'enzyme'","","class User extends React.Component {","  render () {","    return (","      <span>User</span>","    )","  }","}","","class Fixture extends React.Component {","  render () {","    return (","      <div id='root'>","        <User />","      </div>","    )","  }","}","","const wrapper = mount(<Fixture />) // mount/render/shallow when applicable","","expect(wrapper).to.have.descendants('#root')","expect(wrapper).to.have.descendants(User)","","expect(wrapper).to.not.have.descendants('#root1')"]}],[{"start":{"row":157,"column":2},"end":{"row":190,"column":5},"action":"insert","lines":["context('when ultimateChai is used', () => {","    const sampleSuccess = () => new Promise((resolve, reject) => {","     setTimeout(function(){","       resolve({foo: \"bar\"});","     },100); ","    });","    ","    const sampleReject = () => new Promise((resolve, reject) => {","     setTimeout(function(){","       reject(new Error('error'));","     },100); ","    });","        ","    it('should have eventually method from chai-as-promised', () => {","      return expect(sampleSuccess()).to.eventually.have.property(\"foo\");","    });","    ","    it('should have fulfilled method from chai-as-promised', () => {","      return expect(sampleSuccess()).to.be.fulfilled();","    });","    ","    it('should have become method from chai-as-promised', () => {","      return expect(sampleSuccess()).to.become({foo: \"bar\"});","    });","    ","    it('should have rejected method from chai-as-promised', () => {","      return expect(sampleReject()).to.be.rejected();","    });","    ","    it('should have rejected method from chai-as-promised', () => {","      return expect(sampleReject()).to.be.rejectedWith(Error);","    });","    ","  });"],"id":1559}],[{"start":{"row":156,"column":2},"end":{"row":157,"column":0},"action":"insert","lines":["",""],"id":1560},{"start":{"row":157,"column":0},"end":{"row":157,"column":2},"action":"insert","lines":["  "]}],[{"start":{"row":155,"column":5},"end":{"row":156,"column":0},"action":"insert","lines":["",""],"id":1561},{"start":{"row":156,"column":0},"end":{"row":156,"column":2},"action":"insert","lines":["  "]}]]},"ace":{"folds":[],"scrolltop":0,"scrollleft":0,"selection":{"start":{"row":135,"column":43},"end":{"row":135,"column":43},"isBackwards":false},"options":{"guessTabSize":true,"useWrapMode":false,"wrapToView":true},"firstLineState":0},"timestamp":1492188578204}